Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_dh.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_dh.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_dh.F90	(revision 8486)
@@ -12,5 +12,5 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                      LIM3 sea-ice model
+   !!   'key_lim3'                                       LIM3 sea-ice model
    !!----------------------------------------------------------------------
    !!   ice_thd_dh    : vertical accr./abl. and lateral ablation of sea ice
@@ -36,5 +36,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2010)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: icethd_dh.F90 8420 2017-08-08 12:18:46Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -66,8 +66,8 @@
       !!              Vancoppenolle et al.,2009, Ocean Modelling
       !!------------------------------------------------------------------
-      INTEGER  ::   ji , jk        ! dummy loop indices
-      INTEGER  ::   iter
-
-      REAL(wp) ::   ztmelts             ! local scalar
+      INTEGER  ::   ji, jk       ! dummy loop indices
+      INTEGER  ::   iter         ! local integer
+
+      REAL(wp) ::   ztmelts      ! local scalar
       REAL(wp) ::   zdum       
       REAL(wp) ::   zfracs       ! fractionation coefficient for bottom salt entrapment
@@ -104,12 +104,11 @@
       REAL(wp) :: zswitch_sal
 
-      ! Heat conservation 
-      INTEGER  ::   num_iter_max
+      INTEGER  ::   num_iter_max      ! Heat conservation 
       !!------------------------------------------------------------------
 
       ! Discriminate between varying salinity (nn_icesal=2) and prescribed cases (other values)
       SELECT CASE( nn_icesal )                  ! varying salinity or not
-         CASE( 1, 3 ) ;   zswitch_sal = 0._wp   ! prescribed salinity profile
-         CASE( 2 )    ;   zswitch_sal = 1._wp   ! varying salinity profile
+         CASE( 1, 3 )   ;   zswitch_sal = 0._wp   ! prescribed salinity profile
+         CASE( 2 )      ;   zswitch_sal = 1._wp   ! varying salinity profile
       END SELECT
 
@@ -127,6 +126,6 @@
             h_i_old (ji,jk) = ht_i_1d(ji) * r1_nlay_i
             eh_i_old(ji,jk) = e_i_1d(ji,jk) * h_i_old(ji,jk)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
       !
       !------------------------------------------------------------------------------!
@@ -142,5 +141,4 @@
       END DO
 
-      !
       !------------------------------------------------------------------------------!
       ! If snow temperature is above freezing point, then snow melts 
@@ -163,5 +161,4 @@
       !  2) Computing layer thicknesses and enthalpies.            !
       !------------------------------------------------------------!
-      !
       DO jk = 1, nlay_i
          DO ji = 1, nidx
@@ -170,5 +167,5 @@
          END DO
       END DO
-      !
+
       !------------------------------------------------------------------------------|
       !  3) Surface ablation and sublimation                                         |
@@ -389,5 +386,5 @@
       END DO
 
-      !
+
       !------------------------------------------------------------------------------!
       ! 4) Basal growth / melt                                                       !
@@ -664,4 +661,5 @@
    !! ** Purpose :   Compute distribution of precip over the ice
    !!--------------------------------------------------------------------------
+!!gm  I think it can be usefull to set this as a FUNCTION, not a SUBROUTINE....
    SUBROUTINE ice_thd_snwblow_2d( pin, pout )
       REAL(wp), DIMENSION(:,:), INTENT(in   ) :: pin   ! previous fraction lead ( 1. - a_i_b )
@@ -676,12 +674,8 @@
    END SUBROUTINE ice_thd_snwblow_1d
 
-   
 #else
    !!----------------------------------------------------------------------
    !!   Default option                               NO  LIM3 sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE ice_thd_dh          ! Empty routine
-   END SUBROUTINE ice_thd_dh
 #endif
 
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_dif.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_dif.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_dif.F90	(revision 8486)
@@ -18,6 +18,6 @@
    USE par_oce        ! ocean parameters
    USE phycst         ! physical constants (ocean directory) 
-   USE ice            ! LIM-3 variables
-   USE ice1D          ! LIM-3: thermodynamics
+   USE ice            ! sea-ice: variables
+   USE ice1D          ! sea-ice: thermodynamics
    !
    USE in_out_manager ! I/O manager
@@ -31,5 +31,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: icethd_dif.F90 8420 2017-08-08 12:18:46Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -67,5 +67,4 @@
       !!           of temperature
       !!
-      !!
       !! ** Inputs / Ouputs : (global commons)
       !!           surface temperature : t_su_1d
@@ -75,16 +74,5 @@
       !!           profile of the ice/snow layers : z_i, z_s
       !!           total ice/snow thickness : ht_i_1d, ht_s_1d
-      !!
-      !! ** External : 
-      !!
-      !! ** References :
-      !!
-      !! ** History :
-      !!           (02-2003) Martin Vancoppenolle, Louvain-la-Neuve, Belgium
-      !!           (06-2005) Martin Vancoppenolle, 3d version
-      !!           (11-2006) Vectorized by Xavier Fettweis (UCL-ASTR)
-      !!           (04-2007) Energy conservation tested by M. Vancoppenolle
       !!------------------------------------------------------------------
-      !! * Local variables
       INTEGER ::   ji             ! spatial loop index
       INTEGER ::   ii, ij         ! temporary dummy loop index
@@ -796,4 +784,5 @@
    END SUBROUTINE ice_thd_dif
 
+
    SUBROUTINE ice_thd_enmelt
       !!-----------------------------------------------------------------------
@@ -830,8 +819,6 @@
    !!                   Dummy Module                 No LIM-3 sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE ice_thd_dif          ! Empty routine
-   END SUBROUTINE ice_thd_dif
 #endif
+
    !!======================================================================
 END MODULE icethd_dif
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_ent.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_ent.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_ent.F90	(revision 8486)
@@ -15,5 +15,5 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                      LIM3 sea-ice model
+   !!   'key_lim3'                                       LIM3 sea-ice model
    !!----------------------------------------------------------------------
    !!   ice_thd_ent   : ice redistribution of enthalpy
@@ -36,5 +36,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: icethd_ent.F90 8420 2017-08-08 12:18:46Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -86,6 +86,6 @@
             zeh_cum0(ji,jk0) = zeh_cum0(ji,jk0-1) + eh_i_old(ji,jk0-1)
             zh_cum0 (ji,jk0) = zh_cum0 (ji,jk0-1) + h_i_old (ji,jk0-1)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
 
       !------------------------------------
@@ -95,5 +95,5 @@
       DO ji = 1, nidx
          zhnew(ji) = SUM( h_i_old(ji,0:nlay_i+1) ) * r1_nlay_i  
-      ENDDO
+      END DO
 
       ! new layers interfaces
@@ -102,6 +102,6 @@
          DO ji = 1, nidx
             zh_cum1(ji,jk1) = zh_cum1(ji,jk1-1) + zhnew(ji)
-         ENDDO
-      ENDDO
+         END DO
+      END DO
 
       zeh_cum1(:,0:nlay_i) = 0._wp 
@@ -115,7 +115,7 @@
                      &             / ( zh_cum0(ji,jk0) - zh_cum0(ji,jk0-1) )
                ENDIF
-            ENDDO
-         ENDDO
-      ENDDO
+            END DO
+         END DO
+      END DO
       ! to ensure that total heat content is strictly conserved, set:
       zeh_cum1(:,nlay_i) = zeh_cum0(:,nlay_i+2) 
@@ -126,6 +126,6 @@
             rswitch      = MAX( 0._wp , SIGN( 1._wp , zhnew(ji) - epsi20 ) ) 
             qnew(ji,jk1) = rswitch * ( zeh_cum1(ji,jk1) - zeh_cum1(ji,jk1-1) ) / MAX( zhnew(ji), epsi20 )
-         ENDDO
-      ENDDO
+         END DO
+      END DO
 
       ! --- diag error on heat remapping --- !
@@ -143,7 +143,4 @@
    !!   Default option                               NO  LIM3 sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE ice_thd_ent          ! Empty routine
-   END SUBROUTINE ice_thd_ent
 #endif
 
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_lac.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_lac.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_lac.F90	(revision 8486)
@@ -11,5 +11,5 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                      LIM3 sea-ice model
+   !!   'key_lim3'                                       LIM3 sea-ice model
    !!----------------------------------------------------------------------
    !!   lim_lat_acr   : lateral accretion of ice
@@ -20,10 +20,10 @@
    USE sbc_oce , ONLY : sss_m
    USE sbc_ice , ONLY : utau_ice, vtau_ice
-   USE ice1D          ! LIM thermodynamics
-   USE ice            ! LIM variables
-   USE icetab         ! LIM 2D <==> 1D
-   USE icectl         ! LIM conservation
-   USE icethd_ent
-   USE icevar
+   USE ice1D          ! sea-ice: thermodynamics
+   USE ice            ! sea-ice: variables
+   USE icetab         ! sea-ice: 2D <==> 1D
+   USE icectl         ! sea-ice: conservation
+   USE icethd_ent     ! sea-ice: thermodynamics, enthalpy
+   USE icevar         ! sea-ice: operations
    !
    USE in_out_manager ! I/O manager
@@ -35,8 +35,8 @@
    PRIVATE
 
-   PUBLIC ice_thd_lac     ! called by ice_thd
-
-   !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   PUBLIC   ice_thd_lac   ! called by ice_thd
+
+   !!----------------------------------------------------------------------
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: icethd_lac.F90 8420 2017-08-08 12:18:46Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -133,6 +133,6 @@
 
       ! Default new ice thickness
-      WHERE( qlead(:,:) < 0._wp ) ; hicol(:,:) = rn_hnewice
-      ELSEWHERE                   ; hicol(:,:) = 0._wp
+      WHERE( qlead(:,:) < 0._wp )   ;   hicol(:,:) = rn_hnewice
+      ELSEWHERE                     ;   hicol(:,:) = 0._wp
       END WHERE
 
@@ -486,7 +486,4 @@
    !!   Default option                               NO  LIM3 sea-ice model
    !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE ice_thd_lac           ! Empty routine
-   END SUBROUTINE ice_thd_lac
 #endif
 
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_sal.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_sal.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icethd_sal.F90	(revision 8486)
@@ -31,5 +31,5 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: icethd_sal.F90 8420 2017-08-08 12:18:46Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -102,5 +102,4 @@
       !------------------------------------------------------------------------------|
       IF(  nn_icesal == 3  )   CALL ice_var_salprof1d
-
       !
    END SUBROUTINE ice_thd_sal
@@ -119,6 +118,7 @@
       !!-------------------------------------------------------------------
       INTEGER  ::   ios                 ! Local integer output status for namelist read
-      NAMELIST/namicesal/ ln_limdS, nn_icesal, rn_icesal, rn_sal_gd, rn_time_gd,   &
-         &                rn_sal_fl, rn_time_fl, rn_simax, rn_simin 
+      !!
+      NAMELIST/namicesal/ ln_limdS , nn_icesal , rn_icesal, rn_sal_gd, rn_time_gd,   &
+         &                rn_sal_fl, rn_time_fl, rn_simax , rn_simin 
       !!-------------------------------------------------------------------
       !
@@ -126,5 +126,5 @@
       READ  ( numnam_ice_ref, namicesal, IOSTAT = ios, ERR = 901)
 901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namicesal in reference namelist', lwp )
-
+      !
       REWIND( numnam_ice_cfg )              ! Namelist namicesal in configuration namelist : Ice salinity
       READ  ( numnam_ice_cfg, namicesal, IOSTAT = ios, ERR = 902 )
@@ -154,4 +154,5 @@
    !!----------------------------------------------------------------------
 #endif
+
    !!======================================================================
 END MODULE icethd_sal
Index: /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90
===================================================================
--- /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90	(revision 8485)
+++ /branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/iceupdate.F90	(revision 8486)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                       ***  MODULE iceupdate   ***
-   !!           computation of the flux at the sea ice/ocean interface
+   !!  Sea-ice :   computation of the flux at the sea ice/ocean interface
    !!======================================================================
    !! History :   -   ! 2006-07 (M. Vancoppelle)  LIM3 original code
@@ -27,14 +27,18 @@
    USE phycst         ! physical constants
    USE dom_oce        ! ocean domain
-   USE ice            ! LIM sea-ice variables
-   USE sbc_ice , ONLY : emp_oce, qns_oce, qsr_oce, qemp_oce, emp_ice, qsr_ice, qemp_ice, qevap_ice, alb_ice, tn_ice, cldf_ice,  &
+   USE ice            ! sea-ice: variables
+!!gm  It should be probably better to pass these variable in argument of the routine, 
+!!gm  rather than having this long list in USE. This will also highlight what is updated, and what is just use.
+   USE sbc_ice , ONLY : emp_oce, qns_oce, qsr_oce , qemp_oce ,                             &
+      &                 emp_ice, qsr_ice, qemp_ice, qevap_ice, alb_ice, tn_ice, cldf_ice,  &
       &                 snwice_mass, snwice_mass_b, snwice_fmass
    USE sbc_oce , ONLY : nn_fsbc, ln_ice_embd, sfx, fr_i, qsr_tot, qns, qsr, fmmflx, emp, taum, utau, vtau
+!!gm end
    USE sbccpl         ! Surface boundary condition: coupled interface
    USE icealb         ! albedo parameters
    USE traqsr         ! add penetration of solar flux in the calculation of heat budget
    USE domvvl         ! Variable volume
-   USE icectl         !
-   USE bdy_oce  , ONLY: ln_bdy
+   USE icectl         ! ???
+   USE bdy_oce , ONLY : ln_bdy
    !
    USE in_out_manager ! I/O manager
@@ -59,5 +63,5 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! NEMO/ICE 4.0 , NEMO Consortium (2017)
    !! $Id: iceupdate.F90 8411 2017-08-07 16:09:12Z clem $
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -72,5 +76,5 @@
          &      sice_0(jpi,jpj) , vtau_oce(jpi,jpj) , tmod_io(jpi,jpj), STAT=ice_update_alloc)
          !
-      IF( lk_mpp             )   CALL mpp_sum( ice_update_alloc )
+      IF( lk_mpp                )   CALL mpp_sum( ice_update_alloc )
       IF( ice_update_alloc /= 0 )   CALL ctl_warn('ice_update_alloc: failed to allocate arrays')
    END FUNCTION ice_update_alloc
@@ -138,4 +142,6 @@
                zqsr = zqsr - a_i_b(ji,jj,jl) * (  qsr_ice(ji,jj,jl) - ftr_ice(ji,jj,jl) ) 
             END DO
+!!gm  why not like almost everywhere else :
+!!gm        zqsr = qsr_tot(ji,jj) - SUM( a_i_b(ji,jj,:) * (  qsr_ice(ji,jj,:) - ftr_ice(ji,jj,:) )
 
             ! Total heat flux reaching the ocean = hfx_out (W.m-2) 
@@ -170,5 +176,5 @@
             ! mass flux from ice/ocean
             wfx_ice(ji,jj) = wfx_bog(ji,jj) + wfx_bom(ji,jj) + wfx_sum(ji,jj) + wfx_sni(ji,jj)   &
-                           + wfx_opw(ji,jj) + wfx_dyn(ji,jj) + wfx_res(ji,jj) + wfx_lam(ji,jj) 
+               &           + wfx_opw(ji,jj) + wfx_dyn(ji,jj) + wfx_res(ji,jj) + wfx_lam(ji,jj) 
 
             IF ( ln_pnd_fw )   wfx_ice(ji,jj) = wfx_ice(ji,jj) + wfx_pnd(ji,jj)
@@ -189,9 +195,8 @@
             ! Mass of snow and ice per unit area   
             !----------------------------------------
-            ! save mass from the previous ice time step
-            snwice_mass_b(ji,jj) = snwice_mass(ji,jj)                  
-            ! new mass per unit area
+            snwice_mass_b(ji,jj) = snwice_mass(ji,jj)       ! save mass from the previous ice time step
+            !                                               ! new mass per unit area
             snwice_mass  (ji,jj) = tmask(ji,jj,1) * ( rhosn * vt_s(ji,jj) + rhoic * vt_i(ji,jj)  ) 
-            ! time evolution of snow+ice mass
+            !                                               ! time evolution of snow+ice mass
             snwice_fmass (ji,jj) = ( snwice_mass(ji,jj) - snwice_mass_b(ji,jj) ) * r1_rdtice
             
@@ -209,20 +214,19 @@
       !------------------------------------------------------------------------!
       CALL ice_alb( t_su, ht_i, ht_s, a_ip_frac, h_ip, ln_pnd_rad, zalb_cs, zalb_os ) ! cloud-sky and overcast-sky ice albedos
-
-      alb_ice(:,:,:) = ( 1. - cldf_ice ) * zalb_cs(:,:,:) + cldf_ice * zalb_os(:,:,:)
-
-      ! conservation test
-      IF( ln_limdiachk .AND. .NOT. ln_bdy)  CALL ice_cons_final( 'iceupdate' )
-
-      ! control prints
+      !
+      alb_ice(:,:,:) = ( 1._wp - cldf_ice ) * zalb_cs(:,:,:) + cldf_ice * zalb_os(:,:,:)
+
+      !                    ! conservation test
+      IF( ln_limdiachk .AND. .NOT. ln_bdy)   CALL ice_cons_final( 'iceupdate' )
+      !                    ! control prints
       IF( ln_limctl )   CALL ice_prt( kt, iiceprt, jiceprt, 3, ' - Final state ice_update - ' )
-      IF( ln_ctl )      CALL ice_prt3D( 'iceupdate' )
-
-      IF( nn_timing == 1 )  CALL timing_stop('ice_update_flx')
-
+      IF( ln_ctl    )   CALL ice_prt3D( 'iceupdate' )
+      !
+      IF( nn_timing == 1 )   CALL timing_stop('ice_update_flx')
+      !
    END SUBROUTINE ice_update_flx
 
 
-   SUBROUTINE ice_update_tau( kt , pu_oce, pv_oce )
+   SUBROUTINE ice_update_tau( kt, pu_oce, pv_oce )
       !!-------------------------------------------------------------------
       !!                ***  ROUTINE ice_update_tau ***
@@ -312,8 +316,6 @@
       !!                  ***  ROUTINE ice_update_init  ***
       !!             
-      !! ** Purpose : Preparation of the file ice_evolu for the output of
-      !!      the temporal evolution of key variables
+      !! ** Purpose :   ???
       !!
-      !! ** input   : Namelist namicedia
       !!-------------------------------------------------------------------
       INTEGER  ::   ji, jj, jk               ! dummy loop indices
@@ -322,5 +324,5 @@
       !
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'ice_update_init : LIM-3 sea-ice - surface boundary condition'
+      IF(lwp) WRITE(numout,*) 'ice_update_init :   sea-ice   ????'
       IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~~~   '
 
@@ -328,8 +330,7 @@
       IF( ice_update_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'ice_update_init : unable to allocate standard arrays' )
       !
-      soce_0(:,:) = soce                     ! constant SSS and ice salinity used in levitating sea-ice case
+      soce_0(:,:) = soce                     ! constant SSS and ice salinity used in levitating case 0 (i.e. virtual salt flux)
       sice_0(:,:) = sice
-      !                                      ! decrease ocean & ice reference salinities in the Baltic Sea area
-      WHERE( 14._wp <= glamt(:,:) .AND. glamt(:,:) <= 32._wp .AND.   &
+      WHERE( 14._wp <= glamt(:,:) .AND. glamt(:,:) <= 32._wp .AND.   &   ! reduced values in the Baltic Sea area
          &   54._wp <= gphit(:,:) .AND. gphit(:,:) <= 66._wp         ) 
          soce_0(:,:) = 4._wp
@@ -337,5 +338,5 @@
       END WHERE
       !
-      IF( .NOT. ln_rstart ) THEN
+      IF( .NOT.ln_rstart ) THEN              ! set 
          !
          snwice_mass  (:,:) = tmask(:,:,1) * ( rhosn * vt_s(:,:) + rhoic * vt_i(:,:)  )   ! snow+ice mass
@@ -350,8 +351,28 @@
             IF( .NOT.ln_linssh ) THEN
                DO jk = 1,jpkm1                     ! adjust initial vertical scale factors
-                  e3t_n(:,:,jk) = e3t_0(:,:,jk)*( 1._wp + sshn(:,:)*tmask(:,:,1)/(ht_0(:,:) + 1.0 - tmask(:,:,1)) )
-                  e3t_b(:,:,jk) = e3t_0(:,:,jk)*( 1._wp + sshb(:,:)*tmask(:,:,1)/(ht_0(:,:) + 1.0 - tmask(:,:,1)) )
+                  e3t_n(:,:,jk) = e3t_0(:,:,jk) * (  1._wp + sshn(:,:)*tmask(:,:,1) / (ht_0(:,:) + 1._wp - tmask(:,:,1) )  )
+                  e3t_b(:,:,jk) = e3t_0(:,:,jk) * (  1._wp + sshb(:,:)*tmask(:,:,1) / (ht_0(:,:) + 1._wp - tmask(:,:,1) )  )
                END DO
                e3t_a(:,:,:) = e3t_b(:,:,:)
+!!gm  we are in no-restart case, so sshn=sshb   ==>> faster calculation:
+!!    REAL(wp) ::   ze3t   ! local scalar
+!!    REAL(wp), DIMENSION(jpi,jpj) ::   z2d   ! workspace
+!!
+!!             WHERE( ht_0(:,:) > 0 )   ;   z2d(:,:) = 1._wp + sshn(:,:)*tmask(:,:,1) / ht_0(:,:)
+!!             ELSEWHERE                ;   z2d(:,:) = 1._wp
+!!             END WHERE
+!!             DO jk = 1,jpkm1                     ! adjust initial vertical scale factors                
+!!                ze3t = e3t_0(:,:,jk) * z2d(:,:)
+!!                e3t_n(:,:,jk) = ze3t
+!!                e3t_b(:,:,jk) = ze3t
+!!                e3t_a(:,:,jk) = ze3t
+!!             END DO
+!!gm  but since it is only done at the initialisation....  just the following can be acceptable:
+!               DO jk = 1,jpkm1                     ! adjust initial vertical scale factors
+!                  e3t_n(:,:,jk) = e3t_0(:,:,jk) * (  1._wp + sshn(:,:)*tmask(:,:,1) / (ht_0(:,:) + 1._wp - tmask(:,:,1))  )
+!               END DO
+!               e3t_b(:,:,:) = e3t_n(:,:,:)
+!               e3t_a(:,:,:) = e3t_n(:,:,:)
+!!gm end               
                ! Reconstruction of all vertical scale factors at now and before time-steps
                ! =========================================================================
@@ -377,7 +398,7 @@
                gde3w_n(:,:,1) = gdept_n(:,:,1) - sshn(:,:)
                DO jk = 2, jpk
-                  gdept_n(:,:,jk) = gdept_n(:,:,jk-1) + e3w_n(:,:,jk)
+                  gdept_n(:,:,jk) = gdept_n(:,:,jk-1) + e3w_n(:,:,jk  )
                   gdepw_n(:,:,jk) = gdepw_n(:,:,jk-1) + e3t_n(:,:,jk-1)
-                  gde3w_n(:,:,jk) = gdept_n(:,:,jk  ) - sshn   (:,:)
+                  gde3w_n(:,:,jk) = gdept_n(:,:,jk  ) - sshn (:,:)
                END DO
             ENDIF
@@ -387,4 +408,8 @@
    END SUBROUTINE ice_update_init
 
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option         Dummy module          NO  LIM3 sea-ice model
+   !!----------------------------------------------------------------------
 #endif 
 
